import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 
import ddf.minim.signals.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class car1 extends PApplet {




int anzahl_autos = 5;
float bump = 0;
Car[] autos = new Car[anzahl_autos];

Minim minim;
AudioOutput out;
SineWave sine;

public void setup(){
  size(300,400);
  for(int i = 0; i < anzahl_autos; i++) {
    autos[i] = new Car(color(0,random(255),255),random(100),random(height),random(1,5),random(360));
  }
  
  minim = new Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  out = minim.getLineOut(Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new SineWave(840, 0.5f, out.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(0);
  // add the oscillator to the line out
  out.addSignal(sine);
}

public void draw() {
  fill(0,10);
  rectMode(CORNER);
  rect(0,0,width,height);
  for(int i = 0; i < anzahl_autos; i++) {
    autos[i].move();
    autos[i].display();
  }
  sine.setAmp(bump);
  bump = bump * 0.2f;
}

class Car { 
  int c;
  float xpos;
  float ypos;
  float xspeed;
  float direction;
  

  // The Constructor is defined with arguments.
  Car(int tempC, float tempXpos, float tempYpos, float tempXspeed, float tempDirection) { 
    c = tempC;
    xpos = tempXpos;
    ypos = tempYpos;
    xspeed = tempXspeed;
    direction = tempDirection;
    
    
  }

  public void display() {
    noStroke();
    fill(c);
    rectMode(CENTER);
     	
    pushMatrix();
    translate(xpos,ypos);
    rotate(direction/360*4*PI);
    rect(0,0,20,10);
    popMatrix();
    stroke(255,128);
    line(width/2,height/2,xpos,ypos);
  }

  public void move() {
    xpos = xpos + xspeed * sin(direction/360*2*PI);
    ypos = ypos + xspeed * cos(direction/360*2*PI);
    if ((xpos > width) ||
      (ypos > height) ||
      (xpos <= 0) ||
      (ypos <= 0)) {
      direction = direction + 45;
      bump = 1;
    }
  }
}



  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "car1" });
  }
}
