import ddf.minim.*;
import ddf.minim.signals.*;

int anzahl_autos = 5;
float bump = 0;
Car[] autos = new Car[anzahl_autos];

Minim minim;
AudioOutput out;
SineWave sine;

void setup(){
  size(300,400);
  for(int i = 0; i < anzahl_autos; i++) {
    autos[i] = new Car(color(0,random(255),255),random(100),random(height),random(1,5),random(360));
  }
  
  minim = new Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  out = minim.getLineOut(Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new SineWave(840, 0.5, out.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(0);
  // add the oscillator to the line out
  out.addSignal(sine);
}

void draw() {
  fill(0,10);
  rectMode(CORNER);
  rect(0,0,width,height);
  for(int i = 0; i < anzahl_autos; i++) {
    autos[i].move();
    autos[i].display();
  }
  sine.setAmp(bump);
  bump = bump * 0.2;
}
