/*
*  pa_Potentiometer
*  
*  Reads the values which represent the state of a potentiometer 
*  from the serial port and draws a graphical representation.
* 
*  This file is part of the Arduino meets Processing Project.
*  For more information visit http://www.arduino.cc.
*
*  copyleft 2005 by Melvin Ochsmann for Malm� University
*
*/

// importing the processing serial class
import processing.serial.*;

// the display item draws background and grid
  DisplayItems di;

// definition of window size and framerate
  int xWidth = 768;
  int yHeight = 512;
  int fr = 24;
  
// attributes of the display
  boolean bck = true;
  boolean grid = true;
  boolean g_vert = true;
  boolean g_horiz = false;
  boolean g_values = true;
  boolean output = true;
  
// variables for serial connection, portname and baudrate have to be set 
  Serial port;
  String portname = "COM2";  
  int baudrate = 9600;
  int value = 0; 
  String buf=""; 
  int value1=0;  

// variables to draw graphics
  int xpos; 

// lets user control DisplayItems properties and value output in console
void keyPressed(){
  if (key == 'b' || key == 'B') bck=!bck;  // background black/white
  if (key == 'g' || key == 'G') grid=!grid;  // grid ON/OFF 
  if (key == 'v' || key == 'V') g_values=!g_values;  // grid values ON/IFF   
  if (key == 'o' || key == 'O') output=!output;   //turns value output ON/OFF
}

void setup(){
  // set size and framerate
  size(xWidth, yHeight); 
  // establish serial port connection      
  port = new Serial(this, portname, baudrate);
  println(port);
  // create DisplayItems object
  di = new DisplayItems();
}

void drawPotiState(){
   noStroke();
   fill(0, 0, 255);
   // draw rectangfle at xpos 
    rect(xpos, 0, width/32+(xpos/200), height);
    fill(255);
    // and xpos as text
    text(""+xpos , xpos, height/2);
}

void serialEvent(int serial){
  // if serial event is not a line break 
  if(serial!=10) {        
    // add event to buffer
    buf += char(serial);          
    } else {
    // if serial is line break set value1 to buff and clear it
    value1 = int(buf);
    buf="";
    }
    // convert value1 to xpos
    xpos = constrain ( ( ((value1-100)*(width+100))/width )  ,0, width-12); 
    if(output) println("xpos: "+xpos);
}

// draw listens to serial port, draw 
void draw(){
// listen to serial port and trigger serial event  
  while(port.available() > 0){
        value = port.read();
        serialEvent(value);
    }
 // draw background, then PushButtonState and finally rest of DisplayItems   
    di.drawBack();
    drawPotiState();
    di.drawItems();  
}
